Bug 445151 - Review Request: merkaartor - openstreetmap editor
Review Request: merkaartor - openstreetmap editor
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Jon Ciesla
Fedora Extras Quality Assurance
:
Depends On: Qt44
Blocks:
  Show dependency treegraph
 
Reported: 2008-05-04 18:10 EDT by Sven Lankes
Modified: 2009-05-22 12:53 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-07-25 14:15:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
limburgher: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Sven Lankes 2008-05-04 18:10:56 EDT
This is my first package - I will need a sponsor.

Spec URL: http://sven.lank.es/Fedora/SPECS/merkaartor.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/merkaartor-0.0.10-2.fc9.src.rpm
Description: 
Merkaartor is a small editor for OpenStreetMap available under the
GNU General Public License and developed  using the Qt toolkit.
Comment 1 Sven Lankes 2008-05-07 19:54:40 EDT
Minor update - preserve timestamps

Spec URL: http://sven.lank.es/Fedora/SPECS/merkaartor.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/merkaartor-0.0.10-3.fc9.src.rpm
Comment 2 Till Maas 2008-05-18 11:14:02 EDT
Your spec does not honor the rpm optflags, you can achieve this here and with
qmake when you run this in %prep:

sed -i 's/CONFIG += debug/CONFIG += release/' Merkaartor.pro

But I do not know what needs to be done for the next release of merkaartor. You
can see whether or not the optflags are honored when you look at the commandline
parameters given to gcc in the build log. They have to include these:
-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector
--param=ssp-buffer-size=4 -m32 -march=i386 -mtune=generic
-fasynchronous-unwind-tables -Werror-implicit-function-declaration
Comment 3 Sven Lankes 2008-05-18 13:11:34 EDT
I assumed (without checking) that qmake NODEBUG=1 was the right thing to do (it
is in the current merkaartor-svn version).

Fixed in:

Spec URL: http://sven.lank.es/Fedora/SPECS/merkaartor.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/merkaartor-0.0.10-4.fc9.src.rpm

I am a little confused about -Werror-implicit-function-declaration - is that an
official optflag already? I remember some discussions on the mailinglist but not
that it was / is added already.
Comment 4 Till Maas 2008-05-18 13:29:56 EDT
(In reply to comment #3)

> I am a little confused about -Werror-implicit-function-declaration - is that an
> official optflag already? I remember some discussions on the mailinglist but not
> that it was / is added already.

No, sorry for the confusion, I edited my .rpmrc to include it. 

Comment 5 Sven Lankes 2008-05-18 17:11:40 EDT
After switching my main development machine from x86_64 to i386 merkaartor
stopped working on gpx files larger than a couple of kb. While I was unable to
find out the real reason (qt internals it seems) I figured out that it will work
fine when compiled against qt 4.4 instead of 4.3 - so I'm adding a bz dependency
here.

x86_64 works fine with qt 4.3 - it's just i386 that doesn't.
Comment 6 Martin-Gomez Pablo 2008-06-08 12:10:16 EDT
I've checked the package, and I have some remarks :

* "BuildRequires:  gcc gcc-c++" is unneeded ( see:
https://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions )

* Always use the %{name} instead of merkaartor (except in %description,
%changelog and in the header)

* With "%{_datadir}/pixmaps/*.xpm", you are owning all the xpm files, use
%{name}.xpm instead.

Comment 7 Sven Lankes 2008-06-14 15:51:56 EDT
Thanks for your comments. Fixed in:

Spec URL: http://sven.lank.es/Fedora/SPECS/merkaartor.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/merkaartor-0.0.10-5.fc9.src.rpm
Comment 8 Martin-Gomez Pablo 2008-06-19 14:40:28 EDT
Ok, some other points which I've not pointed out before :

* qt4 is a Requires, not a BuildRequires.

* Mock build perfectly without "BuildRequires:  xorg-x11-proto-devel
xorg-x11-xtrans-devel", are they usefull ?

* The software doesn't use make install, so you can remove this line : "make
INSTALL_ROOT=$RPM_BUILD_ROOT install".
Comment 9 Sven Lankes 2008-06-25 17:10:07 EDT
> qt4 is a Requires, not a BuildRequires.

And the requires isn't even needed. Removed

> Mock build perfectly without "BuildRequires:  xorg-x11-proto-devel
> xorg-x11-xtrans-devel", are they usefull ?

No - I don't remember where I got those from - works fine without as 
far as I can see.

> The software doesn't use make install, so you can remove
> this line : "make INSTALL_ROOT=$RPM_BUILD_ROOT install".

Right - this will probably change with the - soon to be released (TM) version
0.11. I have removed the line.

Thanks for your comments - updated files:

Spec URL: http://sven.lank.es/Fedora/SPECS/merkaartor.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/merkaartor-0.0.10-6.fc9.src.rpm
Comment 10 Martin-Gomez Pablo 2008-06-26 10:06:00 EDT
Ok, for me, the package and the spec are good. You just need to wait for a
sponsor to come.
Comment 11 Jon Ciesla 2008-07-24 16:09:40 EDT
I'll do a formal review and I can sponsor you.  You'll need to create an account
in the Fedora Account System, sign the CLA, etc, and then request membership in
the cvsextras group.  I'll send you invites for these.  Review to follow.
Comment 12 Jon Ciesla 2008-07-24 16:17:40 EDT
- MUST: rpmlint must be run on every package. The output should be posted in the
review.

Multiple errors like the following:
merkaartor-debuginfo.i386: W: spurious-executable-perm
/usr/src/debug/merkaartor/Interaction/CreateAreaInteraction.cpp
The file is installed with executable permissions, but was identified as one
that probably should not be executable.  Verify if the executable bits are
desired, and remove if not.

Check the permissions on the source code in the tarball.  If they're executable,
correct this in the spec to silence this warning.

- MUST: The package must be named according to the  Package Naming Guidelines .
Good.

- MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption on  Package Naming Guidelines .
Good.

- MUST: The package must meet the Packaging Guidelines .
Good.

- MUST: The package must be licensed with a Fedora approved license and meet the
Licensing Guidelines .
Good.

- MUST: The License field in the package spec file must match the actual license.
Change license tag to GPLv2+

- MUST: If (and only if) the source package includes the text of the license(s)
in its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.
Good.

- MUST: The spec file must be written in American English.
Good.

- MUST: The spec file for the package MUST be legible. If the reviewer is unable
to read the spec file, it will be impossible to perform a review. Fedora is not
the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
Good.

- MUST: The sources used to build the package must match the upstream source, as
provided in the spec URL. Reviewers should use md5sum for this task. If no
upstream URL can be specified for this package, please see the  Source URL
Guidelines for how to deal with this.
md5 matches.

- MUST: The package must successfully compile and build into binary rpms on at
least one supported architecture.
Builds great here.

- MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch needs to have a bug filed
in bugzilla, describing the reason that the package does not compile/build/work
on that architecture. The bug number should then be placed in a comment, next to
the corresponding ExcludeArch line. New packages will not have bugzilla entries
during the review process, so they should put this description in the comment
until the package is approved, then file the bugzilla entry, and replace the
long explanation with the bug number. The bug should be marked as blocking one
(or more) of the following bugs to simplify tracking such issues:
FE-ExcludeArch-x86 , FE-ExcludeArch-x64 , FE-ExcludeArch-ppc , FE-ExcludeArch-ppc64 
N/A

More to come. . .
Comment 13 Jon Ciesla 2008-07-24 16:30:30 EDT
- MUST: All build dependencies must be listed in BuildRequires, except for any
that are listed in the [wiki:Self:Packaging/Guidelines#Exceptions exceptions
section of Packaging Guidelines] ; inclusion of those as BuildRequires is
optional. Apply common sense.
Mock build pending.

- MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
Good.

- MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun. If the package has multiple subpackages with libraries, each
subpackage should also have a %post/%postun section that calls /sbin/ldconfig.
An example of the correct syntax for this is:

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

N/A

- MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.

N/A

- MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. Refer to the Guidelines for examples.

Good.

- MUST: A package must not contain any duplicate files in the %files listing.

Good.

- MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.

See rpmlint output above.

- MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} ([wiki:Self:Packaging/Guidelines#UsingBuildRootOptFlags or
$RPM_BUILD_ROOT] ).

Good.

- MUST: Each package must consistently use macros, as described in the
[wiki:Self:Packaging/Guidelines#macros macros section of Packaging Guidelines] .

Good.

- MUST: The package must contain code, or permissable content. This is described
in detail in the [wiki:Self:Packaging/Guidelines#CodeVsContent code vs. content
section of Packaging Guidelines] .

Good.

- MUST: Large documentation files should go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity)
- MUST: If a package includes something as %doc, it must not affect the runtime
of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.
- MUST: Header files must be in a -devel package.
- MUST: Static libraries must be in a -static package.

N/A.

- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
directory ownership and usability).
- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel package.
- MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release}
- MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.

N/A.

- MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section. This is described in detail in the
[wiki:Self:Packaging/Guidelines#desktop desktop files section of Packaging
Guidelines] . If you feel that your packaged GUI application does not need a
.desktop file, you must put a comment in the spec file with your explanation.

Good.

- MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another package
owns, then please present that at package review time.

Good.

- MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}
([wiki:Self:Packaging/Guidelines#UsingBuildRootOptFlags or $RPM_BUILD_ROOT] ).
See [wiki:Self:Packaging/Guidelines#PreppingBuildRootForInstall Prepping
BuildRoot For %install] for details.

Good.

- MUST: All filenames in rpm packages must be valid UTF-8.

Good.

Most of the SHOULDs are OK or NA.  Once I finish my mock build I'll have an idea
of any BuildRequires problems. So far the only MUSTFIXs are the license tag and
the permissions on the source files.
Comment 14 Sven Lankes 2008-07-24 16:54:18 EDT
> - MUST: The License field in the package spec file must match the 
> actual license. Change license tag to GPLv2+

I don't think GPLv2+ is correct. The licensing information in the tarball does
need to be improved and I'll try to get that process started. There are two
places where GPLv2 is  mentioned - the webpage
(http://www.irule.be/bvh/c++/merkaartor/ - not relevant for the package) and the
About-Dialog: "This program is licensed under the GNU Public License v2"
Comment 15 Jon Ciesla 2008-07-24 16:57:40 EDT
The comments in parts of the source, it says v2 or any later version.  If they
intend GPLv2 only, they need to say that.  Until they do, it needs to be GPLv2+,
or at least: License: GPLv2 and GPLv2+.


Mock build is OK, so the BuildRequires are good.
Comment 16 Sven Lankes 2008-07-24 17:14:07 EDT
You're right wrt. the mentioning of GPLv2+ - but according to 

http://fedoraproject.org/wiki/Licensing/FAQ

GPLv2 ist still correct for the package:

> The source code contains some .c files which are GPLv2 and some other .c 
> files which are GPLv2+. They're compiled together to form an executable. In 
> this case, the stricter license wins, so the resulting executable is GPLv2. 
> The License tag should read: License: GPLv2 Note that you do NOT need to list 
> GPLv2 and GPLv2+ in the License tag. 
Comment 17 Jon Ciesla 2008-07-24 17:22:37 EDT
I sit corrected.  Should be just the perms issue then (saw your email).  I
suspect a %{__chmod} 644 *.h and .cpp or somesuch, prior to the build, would be ok.
Comment 18 Sven Lankes 2008-07-24 17:47:47 EDT
rpmlint is happy now - updated files:

Spec URL: http://sven.lank.es/Fedora/SPECS/merkaartor.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/merkaartor-0.0.10-7.fc10.src.rpm
Comment 19 Jon Ciesla 2008-07-25 10:11:47 EDT
Looks great now.

APPROVED.

I also appoved your cvsextras membership and officially sponsored you, so you
can make the cvsadmin request here, and then do your import and builds once
that's been completed.

If you need any help with any of that, shoot me an email.

Welcome aboard!
Comment 20 Sven Lankes 2008-07-25 10:27:46 EDT
New Package CVS Request
=======================
Package Name: merkaartor
Short Description: QT-Based OpenStreetMap editor
Owners: slankes
Branches: F-10
InitialCC:
Cvsextras Commits: yes
Comment 21 Jon Ciesla 2008-07-25 10:34:19 EDT
In this case, F-10 has not been branched off yet, and is still referred to as
devel.  devel is always creted by default.  Might consider changing Branches: to
F-9, if you want the stable branch as well (recommended)
Comment 22 Sven Lankes 2008-07-25 10:38:09 EDT
It will work in F-9 as soon as qt4.4 hits F-9 (should be any day now) so:

New Package CVS Request
=======================
Package Name: merkaartor
Short Description: QT-Based OpenStreetMap editor
Owners: slankes
Branches: F-9
InitialCC:
Cvsextras Commits: yes
Comment 23 Jon Ciesla 2008-07-25 10:47:50 EDT
Works there now, that's what I reviewed it on. :) Do you mean you'll hold off
until then to build it?  That makes sense.
Comment 24 Sven Lankes 2008-07-25 11:00:37 EDT
(In reply to comment #23)

> Works there now, that's what I reviewed it on. :) Do you mean you'll hold off
> until then to build it?  That makes sense.

See comment #5 - it does work with qt 4.3 (f9) but if you're on i386 then 
loading gpx-tracks larger than a couple of K doesn't work. Works fine on 
x86_64 and also with qt4.4 - so I will build it as soon as qt4.4 is in f-9.
Comment 25 Jon Ciesla 2008-07-25 11:06:30 EDT
Works for me.
Comment 26 Sven Lankes 2008-07-25 12:22:23 EDT
Maybe the problem has been fixed with a qt update in the meantime then. I'll
retest this.
Comment 27 Jon Ciesla 2008-07-25 12:29:36 EDT
Sorry, I sometimes Fail at English.

I didn't mean that functionality worked for me, I meant that the plan works for
me.  As in, sounds prudent, go ahead. :)
Comment 28 Kevin Fenzi 2008-07-25 12:54:43 EDT
cvs done.
Comment 29 Jon Ciesla 2008-07-25 14:18:47 EDT
FYI, instead of closing bugs manually, you can add the BZ# to the Bodhi update,
and let Bodhi close it.  This will provide additional tracking.
Comment 30 Fedora Update System 2008-09-08 16:16:42 EDT
merkaartor-0.11-2.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/merkaartor-0.11-2.fc9
Comment 31 Fedora Update System 2008-09-16 19:20:30 EDT
merkaartor-0.11-2.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.